package Ezhash;

use strict;
use Carp;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $AUTOLOAD);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT_OK = qw(ezhash);
@EXPORT = qw(ezhash);

$VERSION = '0.03';

sub AUTOLOAD {
    # This AUTOLOAD is used to 'autoload' constants from the constant()
    # XS function.  If a constant is not found then control is passed
    # to the AUTOLOAD in AutoLoader.

    my $constname;
    ($constname = $AUTOLOAD) =~ s/.*:://;
    my $val = constant($constname, @_ ? $_[0] : 0);
    if ($! != 0) {
	if ($! =~ /Invalid/) {
	    $AutoLoader::AUTOLOAD = $AUTOLOAD;
	    goto &AutoLoader::AUTOLOAD;
	}
	else {
		croak "Your vendor has not defined Ezhash macro $constname";
	}
    }
    eval "sub $AUTOLOAD { $val }";
    goto &$AUTOLOAD;
}

bootstrap Ezhash $VERSION;

# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Ezhash - Perl extension for ezmlm string hashes

=head1 SYNOPSIS

  use Ezhash;
  my $hash = ezhash("tom@izb.net"); # $hash is 15

=head1 DESCRIPTION

This module exports one funktion, B<ezhash>, which computes a special
hash number of a string. This hash is used by ezmlm in its subscriber
database.

The funktion B<ezhash> helps you to manipulate a ezmlm subscriber database,
for example from within a cgi script or something.

The hash is a number within 0 to 53, zero-padded. It is only used by
ezmlm itself for performance reasons. Do not use it otherwise.

=head1 AUTHOR

Thomas Linden <tom@izb.net>

=head1 COPYRIGHT

Copyright B<(c)> 2002 IZB Informatik Zentrum.

=head1 SEE ALSO

http://www.ezmlm.org/

=cut
